#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n,o,a,b,ab,O=0,B=0,A=0,AB=0;
    cin>>n>>o>>a>>b>>ab;
    string grupa[n];
    int jedinice[n];
    int Og[n]={0},Ag[n]={0},Bg[n]={0},ABg[n]={0};
    for(int i=0; i<n; i++)
    {
        cin>>grupa[i];
        cin>>jedinice[i];
        if(grupa[i]=="O")
        {
            O=O+jedinice[i];
            Og[i]=jedinice[i];
            o=o-jedinice[i];
        }
        if(grupa[i]=="A")
        {
            A=A+jedinice[i];

        }
        if(grupa[i]=="B")
        {
            B=B+jedinice[i];
        }
        if(grupa[i]=="AB")
        {
            AB=AB+jedinice[i];
        }

    }
    if(o<0)
    {
        cout<<"nemoguce";
        return 0;
    }
    for(int i=0; i<n; i++)
    {
       if(grupa[i]=="A")
       {
           if((a<0 || a==0) && (o<jedinice[i]))
           {
               cout<<"nemoguce";
               return 0;
           }
           if(a-jedinice[i]>0 || a-jedinice[i]==0)
           {
               a=a-jedinice[i];
               Ag[i]=jedinice[i];
           }
           else
           {
               if(a>0)
               {
                 Ag[i]=a;
                 jedinice[i]=jedinice[i]-a;
                 a=0;
               }
               o=o-jedinice[i];
               Og[i]=jedinice[i];

           }
      }
      if(grupa[i]=="B")
       {
           if((b<0 || b==0) && (o<jedinice[i]))
           {
               cout<<"nemoguce";
               return 0;
           }
           if(b-jedinice[i]>0 || b-jedinice[i]==0)
           {
               b=b-jedinice[i];
               Bg[i]=jedinice[i];
           }
           else
           {
               if(b>0)
               {
                 Bg[i]=a;
                 jedinice[i]=jedinice[i]-b;
                 b=0;
               }
               o=o-jedinice[i];
               Og[i]=jedinice[i];

           }
      }
      if(grupa[i]=="AB")
      {
          if(a+b+ab+o<jedinice[i])
          {
              cout<<"nemoguce";
              return 0;
          }
          if(a>0)
          {
              if(a>=jedinice[i])
              {
                  a=a-jedinice[i];
                  Ag[i]=jedinice[i];
                  jedinice[i]=0;

              }
              else
              {
                  jedinice[i]=jedinice[i]-a;
                  Ag[i]=a;
                  a=0;

              }

         }
         if(b>0)
         {
             if(b>=jedinice[i])
              {
                  b=b-jedinice[i];
                  Bg[i]=jedinice[i];
                  jedinice[i]=0;

              }
              else
              {
                  jedinice[i]=jedinice[i]-b;
                  Bg[i]=b;
                  b=0;

              }
         }
         if(ab>0)
         {
             if(ab>=jedinice[i])
              {
                  ab=ab-jedinice[i];
                  ABg[i]=jedinice[i];
                  jedinice[i]=0;

              }
              else
              {
                  jedinice[i]=jedinice[i]-ab;
                  ABg[i]=ab;
                  ab=0;

              }
         }
         if(o>0)
         {
           if(o>=jedinice[i])
              {
                  o=o-jedinice[i];
                  Og[i]=jedinice[i];
                  jedinice[i]=0;

              }
              else
              {
                  jedinice[i]=jedinice[i]-o;
                  Og[i]=o;
                  o=0;

              }
         }
         if(jedinice[i]>0)
         {
             cout<<"nemoguce";
             return 0;
         }



    }

    }
    cout<<"moguce"<<endl;
    for(int i=0; i<n; i++)
    {
        cout<<Og[i]<<" "<<Ag[i]<<" "<<Bg[i]<<" "<<ABg[i]<<endl;
    }
    return 0;
}